Subject: RE: bug#43702: Emacs master: Incorrect highlighting in regexp isearch.

From: Drew Adams <[email-masked]>
Date: Wed, 30 Sep 2020 14:28:27 -0700 (PDT)

> Also I don't understand why users would need so many faces (9!)
> 
> Maybe better to do what Drew proposed: to distinguish the odd groups
> from the even groups, i.e. to have only 2 additional faces
> (a brighter face like the current isearch-group-1 for the odd groups,
> and a darker face for the even groups).

To be clear, I didn't propose that.  My code has 8 levels
(groups), with 8 faces.

What I mentioned about even and odd is for lazy-highlighting.

I use a different face, `isearchp-lazy-odd-regexp-groups',
for odd subgroups - for lazy-highlighting only.

(And that face is used, like the group highlighting for the
current search hit, only when option
`isearchp-highlight-regexp-group-levels-flag' is non-nil.)

I provide 8 levels/groups for the current search hit.
I agree that most regexp searches don't use anywhere near
that many groups.  But it costs nothing to provide for them.

Here's a screenshot with 5 levels shown:

https://www.emacswiki.org/emacs/Icicles_-_Search_Commands%2c_Overview#SearchHighlightingContextLevels

(That's an Icicles-search screenshot, but the effect is the
same.  I added this regexp-group highlighting to Icicles
nine years before I got around to adding it to Isearch+.)